//
// DesktopvOC̃\[Xt@CłB
//
//---------------------------------------------------------------------------
#if !defined(_DEBUG) && !defined(NDEBUG)
#define NDEBUG
#endif
#include <assert.h>

#include <stdio.h>
#include <windows.h>

#ifdef _MSC_VER
#define snprintf _snprintf_s
#define strncpy(d,s,n) strcpy_s(d,n,s)
#endif

// plugin include file --------------
#include "../Plugin.h"
#include "../MkaeApi.h"

// global variables -----------------
HINSTANCE g_hinst;
HWND g_hwnd;
const char * g_classname  = "MadokaeDll_Desktop";
const char * g_pluginname = "Desktop";
char g_inifname[_MAX_PATH+2]; // `ۑpInit@C

MkaeAPI g_MkaeApi;
unsigned int g_customlist_uid = 0;
HICON g_hicons_desktop;
HICON g_hiconl_desktop;

MkaePluginMenu_t g_mymenu[] = {
        {1, 0, "fXNgbv\(&T)", "", "MyToggleEnable",  ""},
};

struct orglist_t {
        char * buf;
        int len;
};
struct orglist_t g_orgmlist;
struct orglist_t g_orgclist;

struct Features_t {
        int is_enable;
        char enable_shortcut[MAX_SHORTCUT];
} g_fea;

// static function prototypes -------
int  DllProcessAttach(HINSTANCE hinstDLL, LPVOID lpvReserved);
void DllProcessDetach(LPVOID lpvReserved);

// callback -------------------------
extern "C" __declspec(dllexport) void __stdcall MyCallBackOption(const char *);
extern "C" __declspec(dllexport) void __stdcall MyCallBackVersion(const char *);
extern "C" __declspec(dllexport) void __stdcall MyToggleEnable(const char *);

extern "C" __declspec(dllexport) int  __stdcall MyNewCustomList(
        const MkaeList_t *, const int,
        const MkaeCustomList_t *, const int);
extern "C" __declspec(dllexport) void __stdcall MyGetCustomList(
        MkaeList_t * o_mlist, const int i_mlistlen,
        MkaeCustomList_t * o_clist, const int i_clistlen);
extern "C" __declspec(dllexport) void __stdcall MyDeleteCustomList(void);

void set_foreground_window(HWND i_hwnd) {
        // Thread̃Cvbg̃A^b`
        int self_thread_id, active_thread_id;
	active_thread_id = ::GetWindowThreadProcessId(::GetForegroundWindow(), NULL);
        self_thread_id = ::GetCurrentThreadId();
        ::AttachThreadInput(self_thread_id, active_thread_id, TRUE);

        // ZorferɎĂ
        ::SetForegroundWindow(i_hwnd); // tHAOEhɎĂ

        // Thread؂藣
        ::AttachThreadInput(self_thread_id, active_thread_id, FALSE);
}

//---------------------------------------------------------------------------
// DllMain
//---------------------------------------------------------------------------
#ifdef __BORLANDC__
#pragma argsused
#endif
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fwdreason, LPVOID lpvReserved)
{
        switch (fwdreason) {
        case DLL_PROCESS_ATTACH: {
                if (0 != DllProcessAttach(hinstDLL, lpvReserved))
                        return 0; // error
                break;
        }
        case DLL_THREAD_ATTACH:
                break;
        case DLL_THREAD_DETACH:
                break;
        case DLL_PROCESS_DETACH:
                DllProcessDetach(lpvReserved);
                break;
        } // end of switch(fwdreason)
        return 1;
}
//---------------------------------------------------------------------------
 
int
DllProcessAttach(HINSTANCE hinstDLL, LPVOID lpvReserved)
{
        g_hinst = (HINSTANCE) hinstDLL;

        // APIL
        if (false == g_MkaeApi.IsEnable())
                return -1; // error

        // ւ̃o[W擾 (菈͖쐬)
        char version[80];
        g_MkaeApi.GetVersion(version, sizeof(version));

        // <vOC>.ini ̍쐬
        char mdlname[_MAX_PATH+2];
        GetModuleFileName((HINSTANCE)hinstDLL, mdlname, _MAX_PATH);
        LPSTR pext = strrchr(mdlname, '.');
        if (pext) *pext = '\0';
        snprintf(g_inifname, sizeof(g_inifname), "%s.ini", mdlname);

        return 0;
}

void
DllProcessDetach(LPVOID lpvReserved)
{
        // nothing to do
}

//---------------------------------------------------------------------------
// [Uj[ɐݒ肷R[obN֐
//---------------------------------------------------------------------------
// uݒvIƂɌĂ΂֐
extern "C" __declspec(dllexport) void __stdcall
MyCallBackOption(const char * i_cmdargs)
{

}

// uo[WvIƂɌĂ΂֐
extern "C" __declspec(dllexport) void __stdcall
MyCallBackVersion(const char * i_cmdargs)
{

}

//---------------------------------------------------------------------------
// R[obN֐ (K{֐)
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) void __stdcall
Mkae_OnGetPluginInfo(MkaePluginInfo_t * o_info)
{
        memset(o_info, 0x0, sizeof(*o_info));
        strncpy(o_info->name, g_pluginname, (sizeof(o_info->name)-1));
}

//---------------------------------------------------------------------------
// R[obN֐ (Cӊ֐)
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) int __stdcall
Mkae_OnSetup(HWND i_hwnd_owner)
{
        g_fea.is_enable = ::GetPrivateProfileInt("General", "Enable", 1, g_inifname);
        g_mymenu[0].checked = (g_fea.is_enable) ? true : false; // j[ɔfĂ

        // V[gJbgL[
        ::GetPrivateProfileString(
                "ShortcutKey", "ToggleEnable", "",
                g_fea.enable_shortcut, sizeof(g_fea.enable_shortcut),
                g_inifname);

        if (g_fea.is_enable) {
                if (0 != g_MkaeApi.RegisterCustomList(
                            MyNewCustomList,
                            MyGetCustomList,
                            MyDeleteCustomList,
                            &g_customlist_uid)) {
                        g_customlist_uid = 0; // set error
                }
        }

        // ̃Xgi[̈
        g_orgmlist.buf = NULL;
        g_orgmlist.len = 0;
        g_orgclist.buf = NULL;
        g_orgclist.len = 0;

        // ACR̎擾
        int cnt;
        char icon_path[_MAX_PATH];
        snprintf(icon_path, sizeof icon_path, "%s", "%windir%\\Explorer.exe");
        cnt = ExtractIconEx(icon_path, 3, &g_hiconl_desktop, &g_hicons_desktop, 1);
        if (0 == cnt) {
                // failed get icon
                g_hicons_desktop = NULL;
                g_hiconl_desktop = NULL;
        }
        return 0;
}

extern "C" __declspec(dllexport) void __stdcall
Mkae_OnSetupRootMenu(unsigned int * o_count, MkaePluginMenu_t * o_menu)
{
        // KvȂ, Mkae_OnSetupSubMenu() ̗lɏ.
        // svȂ, ֐ƍ폜.
}

extern "C" __declspec(dllexport) void __stdcall
Mkae_OnSetupSubMenu(unsigned int * o_count, MkaePluginMenu_t * o_menu)
{
        // vfԂ
        *o_count = (sizeof(g_mymenu) / sizeof(g_mymenu[0]));

        if (o_menu != NULL) {
                // o_menuNULLłȂΓe

                // shortcutkeyݒ
                snprintf(g_mymenu[0].shortcut, sizeof(g_mymenu[0].shortcut), 
                         "%s", g_fea.enable_shortcut);
                // j[copy
                memcpy(o_menu, &g_mymenu, sizeof(g_mymenu));
        }
}

extern "C" __declspec(dllexport) int __stdcall
Mkae_OnTeardown()
{
        if (g_orgmlist.buf) {
                // Xgi[̈悪ĂȂ̂ 
                free(g_orgmlist.buf);
                g_orgmlist.buf = NULL;
                g_orgmlist.len = 0;
        }
        if (g_orgclist.buf) {
                // Xgi[̈悪ĂȂ̂ 
                free(g_orgclist.buf);
                g_orgclist.buf = NULL;
                g_orgclist.len = 0;
        }

	if (g_customlist_uid)
	        g_MkaeApi.UnregisterCustomList(g_customlist_uid);

        // init@C֐ݒo
        char work[32];
        snprintf(work, sizeof(work), "%d", g_fea.is_enable);
        ::WritePrivateProfileString("General", "Enable", work, g_inifname);

        // ShortcutKey ......................
        ::WritePrivateProfileString(
                "ShortcutKey", "ToggleEnable", g_fea.enable_shortcut, g_inifname);


        if (g_hicons_desktop)
                DestroyIcon(g_hicons_desktop);
        if (g_hiconl_desktop)
                DestroyIcon(g_hiconl_desktop);
        return 0;
}


//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) void __stdcall
MyToggleEnable(const char * i_cmdargs)
{
        g_fea.is_enable = (g_fea.is_enable) ? 0 : 1;
        g_mymenu[0].checked = (g_fea.is_enable) ? true : false;
        g_MkaeApi.ReloadMenu(g_pluginname);

	if (g_customlist_uid) {
	        g_MkaeApi.UnregisterCustomList(g_customlist_uid);
		g_customlist_uid = 0;

        } else if (g_fea.is_enable) {
                if (0 != g_MkaeApi.RegisterCustomList(
                            MyNewCustomList,
                            MyGetCustomList,
                            MyDeleteCustomList,
                            &g_customlist_uid))
                        g_customlist_uid = 0; // set error
        }
        g_MkaeApi.UpdateList();
}

extern "C" __declspec(dllexport) int  __stdcall
MyNewCustomList(
        const MkaeList_t * i_mlist, const int i_mlistlen,
        const MkaeCustomList_t * i_clist, const int i_clistlen)
{
        int nclist = 0;          // Gg(Ԃl)

        // ̃Xgi[̈j
        if (g_orgmlist.buf) {
                free(g_orgmlist.buf);
                g_orgmlist.buf = NULL;
                g_orgmlist.len = 0;
        }
        if (g_orgclist.buf) {
                free(g_orgclist.buf);
                g_orgclist.buf = NULL;
                g_orgclist.len = 0;
        }

        // Xgi[̈mۂ,ۑĂ
        g_orgmlist.len = i_mlistlen;
        g_orgmlist.buf = (char *)malloc(g_orgmlist.len);
        if (g_orgmlist.buf)
                memcpy(g_orgmlist.buf, (char *)i_mlist, g_orgmlist.len);

        g_orgclist.len = i_clistlen;
        g_orgclist.buf = (char *)malloc(g_orgclist.len);
        if (g_orgclist.buf)
                memcpy(g_orgclist.buf, (char *)i_clist, g_orgclist.len);

        // fXNgbv ǉ
        nclist = i_clistlen / sizeof(MkaeCustomList_t);
        nclist += 1;

        return nclist;
}

extern "C" __declspec(dllexport) void __stdcall
MyGetCustomList(
        MkaeList_t * o_mlist, const int i_mlistlen,
        MkaeCustomList_t * o_clist, const int i_clistlen)
{
        assert(g_orgmlist.len <= i_mlistlen);
        assert(g_orgclist.len <= i_clistlen);

        // ̃XgRs[
        memcpy(o_mlist, g_orgmlist.buf, g_orgmlist.len);
        memcpy(o_clist, g_orgclist.buf, g_orgclist.len);

        // fXNgbvǉĂ
        MkaeCustomList_t * p   = (MkaeCustomList_t *)((char *)o_clist + g_orgclist.len);
        MkaeCustomList_t * lim = (MkaeCustomList_t *)((char *)o_clist + i_clistlen);

        if (p < lim) {
                p->hwnd = GetDesktopWindow();
                snprintf(p->caption, sizeof(p->caption), "fXNgbv");
                p->hicon_s = g_hicons_desktop;
                p->hicon_l = g_hiconl_desktop;
        }
}

extern "C" __declspec(dllexport) void __stdcall
MyDeleteCustomList(void)
{
        // 邱Ƃ͂Ȃ
}

extern "C" __declspec(dllexport) void __stdcall
Mkae_OnWindowActive(const HWND i_hwnd)
{
        if (i_hwnd == GetDesktopWindow()) {
                HWND hwnd_form, hwnd_listview;
                g_MkaeApi.GetWindowHandles(&hwnd_form, &hwnd_listview);
                MSG msg;        // bZ[W󂯎邽߂̃_~[
                while(PeekMessage(&msg, hwnd_form, WM_KEYFIRST, WM_KEYLAST, PM_REMOVE));

                // Win+DL[s
                // fXNgbvւ̃tH[JXWin+DŏɂĂ炦B
                keybd_event(VK_LWIN, 0,0,0);
                keybd_event('D', 0,0,0);
                keybd_event('D', 0,KEYEVENTF_KEYUP,0);
                keybd_event(VK_LWIN, 0,KEYEVENTF_KEYUP,0);
        }
        return;
}
